#include <Date.au3>
#include <String.au3>

;: _EditDoc(ByRef $ListDoc, $aDocInfo, $Base, $NameDoc, $DataDoc) -   
;        $ListDoc -   ( _LoadDocsList())
;        $aDocInfo -   (_ReadDoc())
;        $Base -   
;        $NameDoc -   
;        $DataDoc -   
Func _EditDoc(ByRef $ListDoc, ByRef $aDocInfo, $Base, $NameDoc, $DataDoc)
	If Not IsObj($ListDoc) Then Return 1
	If Not IsArray($aDocInfo) Then Return 2
	$NameDoc = StringRegExpReplace($NameDoc, '[{^|]', ' ')
	$NameDoc = StringStripWS($NameDoc, 7)
	$DataDoc = StringStripWS($DataDoc, 2)
	If Not $NameDoc Or Not $DataDoc Then Return 3
	Local $sInitDoc = ''
	For $i = 0 To UBound($aDocInfo) - 1
		$sInitDoc &= $aDocInfo[$i][0]
	Next
	Local $nSizeNameDoc = StringLen($NameDoc)
	Local $nSizeInitDoc = StringLen($sInitDoc)
	Local $nSizeDataDoc = StringLen($DataDoc), $nLenInit, $nLenNext
	Local $nLastPosDoc, $nPosEndBase, $sNextData = '', $nLenLastPart, $sEmptyString = _StringRepeat(' ', 12)
	If $nSizeNameDoc < 250 Then
		$NameDoc = $NameDoc & _StringRepeat(' ', 250 - $nSizeNameDoc)
	ElseIf $nSizeNameDoc > 250 Then
		Return 5
	EndIf
	Local $hBase = FileOpen($Base, 513)
	If $hBase = -1 Then Return 6
	FileSetPos($hBase, $ListDoc.Item($aDocInfo[0][3])[4], 0)
	FileWrite($hBase, $NameDoc)
	$ListDoc.Key($aDocInfo[0][3]) = StringStripWS($NameDoc, 2)
	$aDocInfo[0][3] = StringStripWS($NameDoc, 2)
	Local $nNumResum = UBound($aDocInfo)
	If $nNumResum = 1 Then
		If $nSizeDataDoc < $nSizeInitDoc Then $DataDoc = $DataDoc & _StringRepeat(' ', $nSizeInitDoc - $nSizeDataDoc)
		FileSetPos($hBase, $aDocInfo[0][1], 0)
		$sNextData = StringLeft($DataDoc, $aDocInfo[0][2] - 12)
		$aDocInfo[0][0] = $sNextData
		FileWrite($hBase, $sNextData)
		$DataDoc = StringTrimLeft($DataDoc, $aDocInfo[0][2] - 12)
		If $DataDoc Then
			FileSetPos($hBase, 0, 2)
			$nPosEndBase = FileGetPos($hBase)
			$nLenLastPart = StringLen($sEmptyString & $DataDoc & $sEmptyString)
			If StringLen($nLenLastPart) < 12 Then
				$nLenLastPart = $nLenLastPart & _StringRepeat(' ', 12 - StringLen($nLenLastPart))
			EndIf
			ReDim $aDocInfo[2][5]
			$aDocInfo[1][0] = $DataDoc
			$aDocInfo[1][1] = $nPosEndBase
			$aDocInfo[1][2] = $nLenLastPart
			$DataDoc = $nLenLastPart & $DataDoc & $sEmptyString
			FileWrite($hBase, $DataDoc)
			FileSetPos($hBase, $aDocInfo[0][1] + $aDocInfo[0][2] - 12, 0)
			FileWrite($hBase, $nPosEndBase)
		EndIf
	ElseIf $nNumResum > 1 Then
		FileSetPos($hBase, $aDocInfo[0][1], 0)
		$sNextData = StringLeft($DataDoc, $aDocInfo[0][2] - 12)
		$nLenInit = StringLen(StringStripWS($aDocInfo[0][0], 2))
		$nLenNext = StringLen(StringStripWS($sNextData, 2))
		If $nLenInit > $nLenNext Then $sNextData = $sNextData & _StringRepeat(' ', $nLenInit - $nLenNext)
		$aDocInfo[0][0] = $sNextData
		FileWrite($hBase, $sNextData)
		$DataDoc = StringTrimLeft($DataDoc, $aDocInfo[0][2] - 12)
		For $i = 1 To $nNumResum - 1
			$sNextData = StringLeft($DataDoc, $aDocInfo[$i][2] - 24)
			$nLenInit = StringLen(StringStripWS($aDocInfo[$i][0], 2))
			$nLenNext = StringLen(StringStripWS($sNextData, 2))
			If $nLenInit > $nLenNext Then $sNextData = $sNextData & _StringRepeat(' ', $nLenInit - $nLenNext)
			If $sNextData Then
				$aDocInfo[$i][0] = $sNextData
				FileSetPos($hBase, $aDocInfo[$i][1] + 12, 0)
				FileWrite($hBase, $sNextData)
				$DataDoc = StringTrimLeft($DataDoc, $aDocInfo[$i][2] - 24)
			Else
				FileSetPos($hBase, $aDocInfo[$i - 1][1] + $aDocInfo[$i - 1][2] - 12, 0)
				FileWrite($hBase, $sEmptyString)
				For $d = $i To $nNumResum - 1
					FileSetPos($hBase, $aDocInfo[$d][1], 0)
					FileWrite($hBase, _StringRepeat(' ', $aDocInfo[$d][2]))
				Next
				ReDim $aDocInfo[$i][5]
				FileClose($hBase)
				Return 0
			EndIf
		Next
		If $DataDoc Then
			FileSetPos($hBase, 0, 2)
			$nPosEndBase = FileGetPos($hBase)
			$nLenLastPart = StringLen($sEmptyString & $DataDoc & $sEmptyString)
			If StringLen($nLenLastPart) < 12 Then
				$nLenLastPart = $nLenLastPart & _StringRepeat(' ', 12 - StringLen($nLenLastPart))
			EndIf
			ReDim $aDocInfo[$nNumResum + 1][5]
			$aDocInfo[$nNumResum][0] = $DataDoc
			$aDocInfo[$nNumResum][1] = $nPosEndBase
			$aDocInfo[$nNumResum][2] = $nLenLastPart
			$DataDoc = $nLenLastPart & $DataDoc & $sEmptyString
			FileWrite($hBase, $DataDoc)
			FileSetPos($hBase, $aDocInfo[$nNumResum - 1][1] + $aDocInfo[$nNumResum - 1][2] - 12, 0)
			FileWrite($hBase, $nPosEndBase)
		EndIf
	EndIf
	FileClose($hBase)
	Return 0
EndFunc   ;==>_EditDoc

;: _RemoveDoc() -    
;        $ListDoc -   ( _LoadDocsList())
;        $aDocInfo -    _ReadDoc()
;        $Base -   
Func _RemoveDoc(ByRef $ListDoc, ByRef $aDocInfo, $Base)
	If Not IsObj($ListDoc) Or Not IsArray($aDocInfo) Then Return 1
	Local $hBase = FileOpen($Base, 513)
	If $hBase = -1 Then Return 2
	For $i = 0 To UBound($aDocInfo) - 1
		FileSetPos($hBase, $aDocInfo[$i][1], 0)
		FileWrite($hBase, _StringRepeat(' ', $aDocInfo[$i][2]))
	Next
	FileSetPos($hBase, $ListDoc.Item($aDocInfo[0][3])[4], 0)
	FileWrite($hBase, _StringRepeat(' ', 250));StringLen($aDocInfo[0][3])))
	FileClose($hBase)
	$ListDoc.Remove($aDocInfo[0][3])
	$aDocInfo = 0
EndFunc   ;==>_RemoveDoc

;: _ReadDoc($ListDoc, $NameIndexDoc, $Base) -    
;        $ListDoc -   ( _LoadDocsList())
;        $NameDoc -    
;        $Base -   
; :  [$i][0];  [0][3];    $ListDoc[0][4]
;                     [$i][1]
;                    [$i][2]
;:  . Ubound
Func _ReadDoc($ListDoc, $NameDoc, $Base)
	If Not IsObj($ListDoc) Then Return 1
	$NameDoc = StringStripWS($NameDoc, 7)
	If Not $NameDoc Or Not $ListDoc.Exists($NameDoc) Then Return 2
	Local $hBase = FileOpen($Base, 512)
	If $hBase = -1 Then Return 3
	Local $sDoc, $aDocInfo[1][4], $nPosResumDoc, $nlengthResumDoc, $sReadResum
	FileSetPos($hBase, $ListDoc.Item($NameDoc)[2], 0)
	$sDoc = FileRead($hBase, $ListDoc.Item($NameDoc)[3])
	$aDocInfo[0][0] = StringTrimRight($sDoc, 12);
	$aDocInfo[0][1] = $ListDoc.Item($NameDoc)[2]; 
	$aDocInfo[0][2] = $ListDoc.Item($NameDoc)[3];
	$aDocInfo[0][3] = $NameDoc; 
	$nPosResumDoc = Number(StringRight($sDoc, 12))
	If $nPosResumDoc Then
		;  
		Local $ind = 2, $ind1 = 1
		FileSetPos($hBase, $nPosResumDoc, 0)
		While 1
			$nlengthResumDoc = Number(FileRead($hBase, 12))
			$sReadResum = FileRead($hBase, $nlengthResumDoc - 24)
			ReDim $aDocInfo[$ind][4]
			$aDocInfo[$ind1][0] = $sReadResum;
			$aDocInfo[$ind1][1] = $nPosResumDoc; 
			$aDocInfo[$ind1][2] = $nlengthResumDoc;
			$ind += 1
			$ind1 += 1
			$nPosResumDoc = Number(FileRead($hBase, 12))
			If Not $nPosResumDoc Then ExitLoop
			FileSetPos($hBase, $nPosResumDoc - FileGetPos($hBase), 1)
		WEnd
		$aDocInfo[$ind1 - 1][0] = StringStripWS($sReadResum, 2);
	Else
		$aDocInfo[0][0] = StringStripWS(StringTrimRight($sDoc, 12), 2)
	EndIf
	FileClose($hBase)
	Return $aDocInfo
EndFunc   ;==>_ReadDoc

; _LoadBase()
;$Base -   
;$ParamWrite: 1-  (, ,), 0-        
;$ObjSearch -   (,,)
;$ParamSearc: 0-  ,1-  ,2-  
;$Accuracy -  .0- ,1- 
;  :
;$aArrayListDocInfo[0] -   ,   -  $ListDoc
;$aArrayListDocInfo[1] -       (  _WriteDoc() -  $LastPosInfo
;   - ($aArrayListDocInfo[0])[0]
;   - ($aArrayListDocInfo[0])[1]
;   - ($aArrayListDocInfo[0])[2]
;    - ($aArrayListDocInfo[0])[3]
;   - ($aArrayListDocInfo[0])[4]|
;   - ($aArrayListDocInfo[0])[5]
Func _LoadBase($Base, $ParamWrite = 1, $ObjSearch = '', $ParamSearch = 0, $Accuracy = 0)
	Local $ListDoc
	If Not $ParamWrite Then
		$ListDoc = ''
	Else
		$ListDoc = ObjCreate("Scripting.Dictionary")
		$ListDoc.CompareMode = 1
		If Not IsObj($ListDoc) Then Return 1
	EndIf
	Local $LastPosInfo = _GetLastPos($Base)
	_LoadDocsList($ListDoc, $Base, $ObjSearch, $ParamSearch, $Accuracy)
	Local $aArrayListDocInfo[2] = [$ListDoc, $LastPosInfo]
	Return $aArrayListDocInfo
EndFunc   ;==>_LoadBase

; _LoadDocsList(ByRef $ListDoc, $Base) -  ,   _CreateArrayDocs()
;$ObjSearch:   .    ,    
;           $ParamSearch: 1-   , 2 -   (  - 25.05.2015 23:27:12), 3 -   
;$Accuracy:  :
;         1 -  (  )
;         0 -  
Func _LoadDocsList(ByRef $ListDoc, $Base, $ObjSearch = '', $ParamSearch = 1, $Accuracy = 0)
	If Not IsObj($ListDoc) Then Return 1
	Local $nSizePage = 8192, $nPosPage, $aDivInfo, $aDivInfoCell, $nInfolength, $nlengthDocInfo, $nPosDocInfo = 12
	Local $hBase = FileOpen($Base, 512), $aInfoDoc[5]
	If $hBase = -1 Then Return 2
	FileSetPos($hBase, 12, 0)
	Local $sReadPage = FileRead($hBase, $nSizePage)
	If @error = -1 Then
		FileClose($hBase)
		Return 3
	EndIf
	Local $nFreeSpace = $nSizePage - StringLen(StringStripWS($sReadPage, 2))
	Local $aDivPage = StringSplit($sReadPage, '{')
	If @error = 1 Or $aDivPage[0] <> 2 Then
		FileClose($hBase)
		Return 4
	EndIf
	Local $Index = 0, $nLenName, $FlagSearch, $Element, $Res, $sCheckName = ''
	$ObjSearch = StringStripWS($ObjSearch, 7)
	If $ObjSearch Then
		$FlagSearch = 1
		Switch $ParamSearch
			Case 1
				$Element = 1
			Case 2
				$Element = 2
			Case 3
				$Element = 3
			Case Else
				$Element = 1
		EndSwitch
		Switch $Accuracy
			Case 0
				$Accuracy = StringInStr; 
				$Res = 0
			Case 1
				$Accuracy = StringCompare; 
				$Res = 1
			Case Else
				$Accuracy = StringInStr
				$Res = 0
		EndSwitch
	EndIf
	While 1
		$nPosPage = Number($aDivPage[1])
		$nInfolength = 25
		$aDivInfo = StringSplit(StringStripWS($aDivPage[2], 2), '^')
		For $i = 1 To $aDivInfo[0]
			$aDivInfoCell = StringSplit($aDivInfo[$i], '|')
			If @error = 1 Or $aDivInfoCell[0] <> 5 Then
				FileClose($hBase)
				Return 5
			EndIf
			$nLenName = StringLen($aDivInfo[$i])
			$nInfolength += $nLenName
			$nlengthDocInfo = $nLenName
			$sCheckName = StringStripWS($aDivInfoCell[1], 2)
			If $sCheckName Then
				If $FlagSearch Then
					If Not $Accuracy(StringStripWS($aDivInfoCell[$Element], 2), $ObjSearch) = $Res Then
						$aInfoDoc[0] = $aDivInfoCell[2]
						$aInfoDoc[1] = $aDivInfoCell[3]
						$aInfoDoc[2] = Number($aDivInfoCell[4])
						$aInfoDoc[3] = Number($aDivInfoCell[5])
						$aInfoDoc[4] = $nPosDocInfo + ($nInfolength - $nLenName) - 12
						$Index += 1
						$ListDoc.Add($sCheckName, $aInfoDoc)
					EndIf
				Else
					$aInfoDoc[0] = $aDivInfoCell[2]
					$aInfoDoc[1] = $aDivInfoCell[3]
					$aInfoDoc[2] = Number($aDivInfoCell[4])
					$aInfoDoc[3] = Number($aDivInfoCell[5])
					$aInfoDoc[4] = $nPosDocInfo + ($nInfolength - $nLenName) - 12
					$Index += 1
					$ListDoc.Add($sCheckName, $aInfoDoc)
				EndIf
			EndIf
			$nInfolength += 1
		Next
		If $nPosPage = 0 Then ExitLoop
		$nPosDocInfo = $nPosPage
		FileSetPos($hBase, $nPosPage - FileGetPos($hBase), 1)
		$sReadPage = FileRead($hBase, $nSizePage)
		$nFreeSpace = $nSizePage - StringLen(StringStripWS($sReadPage, 2))
		$aDivPage = StringSplit($sReadPage, '{')
		If @error = 1 Or $aDivPage[0] <> 2 Then
			FileClose($hBase)
			Return 6
		EndIf
	WEnd
	If $FlagSearch Then ReDim $ListDoc[$Index][6]
	FileClose($hBase)
EndFunc   ;==>_LoadDocsList

; _GetLastPos()-      
; :
;	$LastPosInfo[0]   
;	$LastPosInfo[1]     
;	$LastPosInfo[2]    
Func _GetLastPos($Base)
	Local $nSizePage = 8192, $nPosPage, $nSizeAllInfo
	Local $nLastPosInfo, $nFreeSpace
	Local $LastPosInfo[3]
	Local $hBase = FileOpen($Base, 512)
	If $hBase = -1 Then Return $LastPosInfo
	FileSetPos($hBase, 12, 0)
	Local $sReadPage = FileRead($hBase, 12)
	If @error = -1 Then
		FileClose($hBase)
		Return $LastPosInfo
	EndIf
	Local $nPosBlock = 12
	$nPosPage = Number($sReadPage)
	If $nPosPage Then
		While 1
			FileSetPos($hBase, $nPosPage - FileGetPos($hBase), 1)
			$sReadPage = FileRead($hBase, 12)
			$nPosPage = Number($sReadPage)
			If Not $nPosPage Then
				FileSetPos($hBase, -12, 1)
				$nPosBlock = FileGetPos($hBase)
				$sReadBlock = FileRead($hBase, $nSizePage)
				$nSizeAllInfo = StringLen(StringStripWS($sReadBlock, 2))
				$nFreeSpace = $nSizePage - $nSizeAllInfo
				$nLastPosInfo = $nPosBlock + $nSizeAllInfo
				ExitLoop
			EndIf
		WEnd
	Else
		FileSetPos($hBase, 12, 0)
		$sReadBlock = FileRead($hBase, $nSizePage)
		$nSizeAllInfo = StringLen(StringStripWS($sReadBlock, 2))
		$nFreeSpace = $nSizePage - $nSizeAllInfo
		$nLastPosInfo = $nSizeAllInfo + $nPosBlock
	EndIf
	FileClose($hBase)
	$LastPosInfo[0] = $nPosBlock;  
	$LastPosInfo[1] = $nLastPosInfo;    
	$LastPosInfo[2] = $nFreeSpace;   
	Return $LastPosInfo
EndFunc   ;==>_GetLastPos

; _WriteDoc() -            $ListDoc
Func _WriteDoc(ByRef $ListDoc, ByRef $LastPosInfo, $Base, $NameDoc, $DataDoc, $TypeDoc = 'doc')
	If Not IsArray($LastPosInfo) Then Return 1
	$NameDoc = StringRegExpReplace($NameDoc, '[{^|]', ' ')
	$TypeDoc = StringRegExpReplace($TypeDoc, '[{^|]', ' ')
	$NameDoc = StringStripWS($NameDoc, 7)
	$DataDoc = StringStripWS($DataDoc, 2)
	$TypeDoc = StringStripWS($TypeDoc, 7)
	If Not $NameDoc Or Not $DataDoc Or Not $TypeDoc Then Return 2
	Local $nCheckList = IsObj($ListDoc)
	If $nCheckList Then
		If $ListDoc.Exists($NameDoc) Then Return 3
	EndIf
	Local $hBase = FileOpen($Base, 513)
	If $hBase = -1 Then Return 4
	Local $sDocInfo, $nSizePage = 8192, $nNewDocPos, $nNewListPos, $sDateDoc = _DateTimeFormat(_NowCalc(), 0)
	Local $nSumDoc, $nSizePattern, $sEmptyString = _StringRepeat(' ', 12)
	Local $nDocSize = StringLen($DataDoc & $sEmptyString), $sLastBlock, $nNewIndex, $nSizeStringInfo, $aInfoDoc[5]
	Local $nLenName = StringLen($NameDoc)
	If $nLenName < 250 Then
		$NameDoc = $NameDoc & _StringRepeat(' ', 250 - $nLenName)
	ElseIf $nLenName > 250 Then
		Return 5
	EndIf
	If Not $LastPosInfo[0] Then
		FileSetPos($hBase, 12, 0)
		$sDocInfo = '{' & $NameDoc & '|' & $sDateDoc & '|' & $TypeDoc & '|' & $nSizePage + 12 & '|' & $nDocSize
		$nSizeStringInfo = StringLen($sDocInfo)
		$sLastBlock = _StringRepeat(' ', $nSizePage - $nSizeStringInfo - 12)
		FileWrite($hBase, $sEmptyString & $sDocInfo & $sLastBlock)
		FileWrite($hBase, $DataDoc & $sEmptyString)
		FileClose($hBase)
		If $nCheckList Then
			$aInfoDoc[0] = $sDateDoc
			$aInfoDoc[1] = $TypeDoc
			$aInfoDoc[2] = $nSizePage + 12
			$aInfoDoc[3] = $nDocSize
			$aInfoDoc[4] = 25
			$ListDoc.Add(StringStripWS($NameDoc, 2), $aInfoDoc)
		EndIf
		$LastPosInfo[0] = 12
		$LastPosInfo[1] = $nSizeStringInfo + 24
		$LastPosInfo[2] = $nSizePage - $nSizeStringInfo - 12
	Else
		FileSetPos($hBase, 0, 2)
		$nNewDocPos = FileGetPos($hBase)
		$sDocInfo = '^' & $NameDoc & '|' & $sDateDoc & '|' & $TypeDoc & '|' & $nNewDocPos & '|' & $nDocSize
		$nSizeStringInfo = StringLen($sDocInfo)
		If $nSizeStringInfo <= $LastPosInfo[2] Then
			FileWrite($hBase, $DataDoc & $sEmptyString)
			FileSetPos($hBase, $LastPosInfo[1], 0)
			FileWrite($hBase, $sDocInfo)
			FileClose($hBase)
			If $nCheckList Then
				$aInfoDoc[0] = $sDateDoc
				$aInfoDoc[1] = $TypeDoc
				$aInfoDoc[2] = $nNewDocPos
				$aInfoDoc[3] = $nDocSize
				$aInfoDoc[4] = $LastPosInfo[1] + 1
				$ListDoc.Add(StringStripWS($NameDoc, 2), $aInfoDoc)
			EndIf
			$LastPosInfo[1] = $LastPosInfo[1] + $nSizeStringInfo
			$LastPosInfo[2] = $LastPosInfo[2] - $nSizeStringInfo
		Else
			$nNewListPos = $nNewDocPos
			$sDocInfo = '{' & $NameDoc & '|' & $sDateDoc & '|' & $TypeDoc & '|' & $nNewListPos + $nSizePage & '|' & $nDocSize
			$nSizeStringInfo = StringLen($sDocInfo)
			$sLastBlock = _StringRepeat(' ', $nSizePage - $nSizeStringInfo - 12)
			FileWrite($hBase, $sEmptyString & $sDocInfo & $sLastBlock)
			FileWrite($hBase, $DataDoc & $sEmptyString)
			FileSetPos($hBase, $LastPosInfo[0], 0)
			FileWrite($hBase, $nNewListPos)
			FileClose($hBase)
			If $nCheckList Then
				$aInfoDoc[0] = $sDateDoc
				$aInfoDoc[1] = $TypeDoc
				$aInfoDoc[2] = $nNewListPos + $nSizePage
				$aInfoDoc[3] = $nDocSize
				$aInfoDoc[4] = $nNewListPos + 13
				$ListDoc.Add(StringStripWS($NameDoc, 2), $aInfoDoc)
			EndIf
			$LastPosInfo[0] = $nNewListPos
			$LastPosInfo[1] = $nNewListPos + $nSizeStringInfo + 12
			$LastPosInfo[2] = $nSizePage - $nSizeStringInfo - 12
		EndIf
	EndIf
EndFunc   ;==>_WriteDoc
